// Generated with util/create-component.js
import React, {useState, useEffect} from "react";
import { nanoid } from 'nanoid';
import { CardProps } from "./card.types";

import "./card.less";

const Card: React.FC<CardProps> = ({ options: newOptions, _this }) => {
  const { options } = _this
  const [maskId, setMaskId] = useState(nanoid())
  const {_width = 300, _height = 200} = options
  const boxSize = options.radiusLength + options.radiusWidth
  useEffect(()=>{
    _this.emit('mounted')
  }, [])
  let title = options.title || '';
  return (
    <div
      className="card-box"
      style={{
        position: 'relative', 
        width: _width, 
        height: _height, 
        borderRadius: options.radius,
        borderWidth: options.borderWidth,
        borderColor: options.borderColor,
        borderStyle: 'solid',
        backgroundColor: options.bodyBackground,
        boxShadow: `${options.borderColor} 0px 0px ${options.boxShadowIntensity}px ${options.boxShadowInset ? 'inset': ''}`,
      }}>
       <svg version="1.1"
          style={{
            overflow: "visible",
            position: 'absolute',
            top: 0,
            left: 0,
          }}
          baseProfile="full"
          width="100%"
          height="100%"
          xmlns="http://www.w3.org/2000/svg">
        <mask id={maskId}>
          <g fill="#ffffff">
            <rect 
              x={-options.radiusWidth} 
              y={-options.radiusWidth}  
              width={boxSize} 
              height={boxSize}/>
            <rect 
              x={_width - options.radiusLength} 
              y={-options.radiusWidth}  
              width={boxSize} 
              height={boxSize}/>
            <rect 
              x={-options.radiusWidth}  
              y={_height - options.radiusLength} 
              width={boxSize} 
              height={boxSize}/>
            <rect 
              x={_width - options.radiusLength} 
              y={_height - options.radiusLength}  
              width={boxSize} 
              height={boxSize}/>
          </g>
        </mask>
        <rect 
          x="0%" y="0" 
          rx={options.radius} 
          ry={options.radius} 
          width="100%" height="100%"
          mask={`url(#${maskId})`}
          fill="none" 
          stroke={options.radiusColor} strokeWidth={options.radiusWidth} />
      </svg>
      <div style={{
        lineHeight: `${options.headerHeight}px`,
        height: options.headerHeight,
        paddingLeft: 20,
        position: 'absolute',
        color: '#fff',
        fontSize: '24px',
        zIndex: 1,
      }}
      >{title}</div>
      <div className="card-header mask-vertical" style={{
        height: options.headerHeight,
        textAlign: 'left',
        backgroundSize: `${options.headerSpace}px ${options.headerSpace}px`,
        zIndex: -1,
        position: 'relative',
        backgroundImage: `linear-gradient(-45deg, ${options.headerBackground} 25%, transparent 0, transparent 50%, ${options.headerBackground} 0, ${options.headerBackground} 75%, transparent 0)`  
      }}>
      </div> 
      <img src={`${_this.__resource}/bg.jpg`} alt="" />
    </div>
  )  
};

export default Card;
