require('colors')
const fs = require('fs')
const del = require('delete')
const { string2camel } = require('../tools')
const templates = require('../templates')
const componentName = process.argv[2]
const componentCamelName = string2camel(componentName)

if (!componentName) {
  console.error('Please supply a valid component name'.red)
  process.exit(1)
}

const componentDirectory = `./src/components/${componentName}`

if (fs.existsSync(componentDirectory)) {
  console.error(`find ${componentName} exists start remove.`.green)
  del.sync(componentDirectory)
  const indexText = fs.readFileSync('./src/index.js', 'utf8')
  const replaceText = indexText.replace(`import ${componentCamelName} from './components/${componentName}/index.ts';`, '')
  const lastText = replaceText.replace(`${componentCamelName},`, '')
  fs.writeFileSync('./src/index.js', lastText, 'utf8')
  console.log(
    'Successfully remove component under: ' + componentName
  )
  process.exit(1)
}
